"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const serve_1 = require("./serve");
const build_1 = require("./build");
function electron(config) {
    const name = '@electron-boot/vite-plugin-electron';
    return [{
            name: `${name}:serve`,
            apply: "serve",
            configureServer(server) {
                server.httpServer.on("listening", () => {
                    (0, serve_1.bootstrap)(config, server);
                });
            }
        }, {
            name: `${name}:build`,
            apply: "build",
            async configResolved(viteConfig) {
                await (0, build_1.build)(config, viteConfig);
            },
        }];
}
exports.default = electron;
