"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bootstrap = void 0;
const child_process_1 = require("child_process");
const tscWatchClient = require("tsc-watch/client");
const watch = new tscWatchClient();
async function bootstrap(config, server) {
    const electronPath = require("electron");
    const { config: ViteConfig } = server;
    const address = server.httpServer.address();
    watch.on('started', () => {
        console.log('Compilation started');
    });
    watch.on('first_success', () => {
        console.log('First success!');
    });
    watch.on('success', () => {
        var _a, _b, _c, _d;
        server.printUrls();
        const env = Object.assign(process.env, {
            VITE_LOCAL_SERVER_URL: (((_a = server.resolvedUrls) === null || _a === void 0 ? void 0 : _a.local.length) > 0) ? ((_b = server.resolvedUrls) === null || _b === void 0 ? void 0 : _b.local[0]) : "",
            VITE_NETWORK_SERVER_URL: (((_c = server.resolvedUrls) === null || _c === void 0 ? void 0 : _c.network.length) > 0) ? ((_d = server.resolvedUrls) === null || _d === void 0 ? void 0 : _d.network[0]) : ""
        });
        if (process.electronApp) {
            process.electronApp.removeAllListeners();
            process.electronApp.kill();
        }
        process.electronApp = (0, child_process_1.spawn)(electronPath, ["."], { stdio: "inherit", env });
        // 在应用退出是结束进程
        process.electronApp.once("exit", process.exit);
    });
    watch.on('compile_errors', () => {
        // Your code goes here...
    });
    watch.start('--project', './tsconfig.electron.json');
}
exports.bootstrap = bootstrap;
