import { bootstrap } from "./serve";
import { build } from "./build";
export default function electron(config) {
    const name = '@electron-boot/vite-plugin-electron';
    return [{
            name: `${name}:serve`,
            apply: "serve",
            configureServer(server) {
                server.httpServer.on("listening", () => {
                    bootstrap(config, server);
                });
            }
        }, {
            name: `${name}:build`,
            apply: "build",
            async configResolved(viteConfig) {
                await build(config, viteConfig);
            },
        }];
}
