var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { spawn } from 'child_process';
var tscWatchClient = require("tsc-watch/client");
var watch = new tscWatchClient();
export function bootstrap(config, server) {
    return __awaiter(this, void 0, void 0, function () {
        var electronPath, ViteConfig, address;
        return __generator(this, function (_a) {
            electronPath = require("electron");
            ViteConfig = server.config;
            address = server.httpServer.address();
            watch.on('started', function () {
                console.log('Compilation started');
            });
            watch.on('first_success', function () {
                console.log('First success!');
            });
            watch.on('success', function () {
                var _a, _b, _c, _d;
                server.printUrls();
                var env = Object.assign(process.env, {
                    VITE_LOCAL_SERVER_URL: (((_a = server.resolvedUrls) === null || _a === void 0 ? void 0 : _a.local.length) > 0) ? ((_b = server.resolvedUrls) === null || _b === void 0 ? void 0 : _b.local[0]) : "",
                    VITE_NETWORK_SERVER_URL: (((_c = server.resolvedUrls) === null || _c === void 0 ? void 0 : _c.network.length) > 0) ? ((_d = server.resolvedUrls) === null || _d === void 0 ? void 0 : _d.network[0]) : ""
                });
                if (process.electronApp) {
                    process.electronApp.removeAllListeners();
                    process.electronApp.kill();
                }
                process.electronApp = spawn(electronPath, ["."], { stdio: "inherit", env: env });
                // 在应用退出是结束进程
                process.electronApp.once("exit", process.exit);
            });
            watch.on('compile_errors', function () {
                // Your code goes here...
            });
            watch.start('--project', './tsconfig.electron.json');
            return [2 /*return*/];
        });
    });
}
